=== debian/changelog ===
primesieve (12.11+ds-2) unstable; urgency=medium

  * Lintian fix release, correct mistyping in d/changelog.

 -- Jerome Benoit <calculus@rezozer.net>  Mon, 29 Dec 2025 12:49:11 +0000

primesieve (12.11+ds-1) unstable; urgency=medium

  * New upstream minor version.
  * Debianization:
    - d/patches/*:
      - d/p/upstream-workaround-doc-doxygen-LaTeX-tables-reverse.patch,
        reverse formally patch integrated upstream (thanks in advance
        to the upstream maintainer for his patience) (Closes: #1122454).

 -- Jerome Benoit <calculus@rezozer.net>  Fri, 26 Dec 2025 16:26:59 +0000
