=== debian/changelog ===
primesieve (12.12+ds-1) unstable; urgency=medium

  * New upstream minor version.
  * Debianization:
    - d/{copyright,adhoc/{c,cpp}/Makefile, copyright year-tuples, update;
    - d/patches/*:
      - d/p/upstream-workaround-doc-doxygen-LaTeX-tables-reverse.patch,
        integrated;
    - d/control:
      - Priority field, now reply on the default,
      - Standards-Version, bump to 4.7.3 (no change).

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 01 Feb 2026 13:17:27 +0000
