## primesieve 12.13+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.9...4.2)
 
 project(primesieve
-        VERSION 12.12
+        VERSION 12.13
         LANGUAGES CXX)
 
 # Build options ######################################################
