=== debian/changelog ===
primesieve (12.13+ds-1) unstable; urgency=medium

  * New upstream version.
  * Debianization:
    - d/patches/*:
      - d/p/upstream-fix-substitutingmachinery-prejecversion-mismatch.patch,
        integrated.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 01 Mar 2026 18:39:24 +0000

primesieve (12.12+ds-2) unstable; urgency=medium

  * Debianization:
    - d/patches/*:
      - d/p/upstream-fix-substitutingmachinery-prejecversion-mismatch.patch,
        introduce.

 -- Jerome Benoit <calculus@rezozer.net>  Tue, 03 Feb 2026 21:49:11 +0000
